HDU - 5187 - zhx's contest 附mod方式的小结 ʕ •ᴥ•ʔ

Problem Description

As one of the most powerful brushes, zhx is required to give his juniors  problems.
zhx thinks the  problem's difficulty is . He wants to arrange these problems in a beautiful way.
zhx defines a sequence  beautiful if there is an  that matches two rules below:
1:  are monotone decreasing or monotone increasing.
2:  are monotone decreasing or monotone increasing.
He wants you to tell him that how many permutations of problems are there if the sequence of the problems' difficulty is beautiful.
zhx knows that the answer may be very huge, and you only need to tell him the answer module .

 

Input

Multiply test cases(less than ). Seek  as the end of the file.
For each case, there are two integers  and  separated by a space in a line. ()

 

Output

For each test case, output a single line indicating the answer.

 

Sample Input

 

2 233 3 5

 

Sample Output

 

2 1

题意:从1~n有多少种排列,使得 a1~ai 满足单调递增或者单调递减,ai~an 满足单调递增或者递减。

分析:从n个数种选出i个数 剩下的数要满足单调递增或者递减或者递减的规律那么方式唯一。

ans = (C(N,0)+C(N,1)+......+C(N,N)) =2^N;但是这种情况下 单调递增和单调递减算了两遍  因此要减2。

ans = 2^n - 2;当n为1时,要输出1,而当p为1时要输出0;

但是n,p都是LL型的,快速幂的时候会爆LL,所以这里要用到快速乘法,快速乘法其实和快速幂差不多,就是把乘号改为加

模小结:

取模有很多种方式 这里总结一下

(a + b) % p = (a % p + b % p) % p

(a - b) % p = (a % p - b % p) % p

(a * b) % p = (a % p * b % p) % p

a ^ b % p = ((a % p)^b) % p

如果取模后结果为负  用 ans 举例子 ans<0  (ans+p)%p

#include
#include
#include
#include
#include
using namespace std;
#define ll long long
ll n,p;
ll mul(ll a,ll b)
{
	ll res=0;
	while(b)
	{
		if(b&1)
		res=(res+a)%p;
		a=(a+a)%p;
		b>>=1;
	}
	return res;
}
ll power(ll a,ll b)
{
	ll ans=1;
	while(b)
	{
		if(b&1)
		{
			ans=mul(ans,a)%p;
		}
		a=mul(a,a)%p;
		b>>=1;
	}
	return ans;
}
int main()
{

	while(cin>>n>>p)
	{
		if(p==1)//先判断模多少 再判断n 
		{
			cout<<0<

 

你可能感兴趣的:(HDU - 5187 - zhx's contest 附mod方式的小结 ʕ •ᴥ•ʔ)